﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Threading;
using System.IO.Ports;
using System.Diagnostics;

namespace wuhyuo
{
    /// <summary>
    /// MainWindow.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Initialized(object sender, EventArgs e)
        {
            _thrd = new Thread(InputThread);
            _thrd.Start();
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            _thrd.Abort();
            _thrd.Join();
        }

        private void InputThread()
        {
            try
            {
                using (var port = new SerialPort("COM6", 115200))
                {
                    port.Open();
                    while (true)
                    {
                        try
                        {
                            string input = port.ReadLine();
                            double[] values = input.Split(" \t\r\n".ToArray()).Where(x => x.Length > 0)
                                .Select(x => Convert.ToDouble(x)).ToArray();
                            if (values.Length != 6)
                                continue;

                            Dispatcher.Invoke(() =>
                            {
                                Debug.WriteLine(input);
                                Canvas.SetLeft(rect, values[0] * 10);
                                Canvas.SetRight(rect, values[1] * 10);
                                rectRotate.Angle = values[5] * 180 / Math.PI;
                            });
                        }
                        catch (FormatException) { }
                        catch (TimeoutException) { }
                    }
                }
            }
            catch (InvalidOperationException)
            {
                Dispatcher.Invoke(() =>
                {
                    MessageBox.Show("arduino connection closed");
                    Close();
                });
            }
        }

        private Thread _thrd;
    }
}
